<?php

class bLangue extends BackModule {

    public function bLangue($formvars = array())
    {
        parent::BackModule($formvars);
        $this->droits['DEL'] = false;
    }

    public function Listing($formvars = array())
    {
        $sql = "
            SELECT
                l.langue_id,
                l.langue_id,
                l.langue_nom,
                l.langue_ini
            FROM langue l
            WHERE 1
        ";

        $this->request = $sql;

        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("CODE");
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    public function Form($formvars = array())
    {
        $this->request = getTable('langue', $formvars['id']);

        $data = $this->sql->getOne($this->request);
        $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition de la langue : <strong>" . $data['langue_nom'] . "</strong></a></span>";

        // Champs du formulaire
        //GROUP
        $form = new BackForm("Informations", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Langue ID", "hidden", "langue_id");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "langue_nom");
        $form->addAttr('readonly', 'readonly');
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'langue_boutique');
        $this->addForm($form);
        //-- Champs du formulaire

        return $this->displayForm($formvars['id']);
    }

}
