<?php

class bProduit_attribut_stock extends BackModule {

    function bProduit_attribut($formvars = array()) {
        parent::BackModule($formvars);
    }

    function update($formvars = array(), $table = null, $langue = true)
    {

        $return = parent::update($formvars, $table, $langue);

        return $return;
    }

    function create($formvars = array(), $table = null, $langue = true)
    {

        $return = parent::create($formvars, $table, $langue);

        return $return;
    }

    function Form($formvars = array()) {

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql.=" FROM (produit_attribut_stock pas)";
            $sql.=" WHERE pas.produit_attribut_stock_id = '" . $formvars['id'] . "'";

            $this->request = $sql;
        }
        //-- SQL
        // Champs du formulaire
        //GROUP
        $form = new BackForm("Informations", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Produit att ID", "hidden", "produit_attribut_id");
        $this->addForm($form);

        $form = new BackForm("Type", "select", "stock_type_id");
        $form->addOptionSQL("SELECT stock_type_id, stock_type_nom FROM stock_type ORDER BY stock_type_nom");
        $this->addForm($form);

        $form = new BackForm("Quantité", "text", "produit_attribut_stock_qte");
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    function Listing($formvars = array()) {

        // SQL
        $sql = "SELECT DISTINCT pas.produit_attribut_stock_id";
        $sql.=", pas.produit_attribut_stock_id";

        $sql.=", st.stock_type_nom";
        $sql.=", pas.produit_attribut_stock_qte";

        $sql.=" FROM (produit_attribut_stock pas)";
        $sql.=" INNER JOIN stock_type st ON (st.stock_type_id = pas.stock_type_id)";

        $sql.=" WHERE 1";

        if (!empty($formvars['produit_attribut']))
            $sql.=" AND pas.produit_attribut_id = '" . $formvars['produit_attribut'] . "'";

        //echo $sql;

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("TYPE");
        $this->addLabel($label);

        $label = new BackLabel("Quantit&eacute; en stock");
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

//--
}