<?php

class bTemoignage extends BackModule {

    function bTemoignages($formvars = array()) {
        parent::BackModule($formvars);
    }
    
    function create($formvars = array(), $table = null, $langue = true) {

        if(empty($formvars['client_id'])) $formvars['client_id']='NULL';

        $return = parent::create($formvars, $table, $langue);

        return $return;
    }
    
    function update($formvars = array(), $table = null, $langue = true) {

        if(empty($formvars['client_id'])) $formvars['client_id']='NULL';

        $return = parent::update($formvars, $table, $langue);

        return $return;
    }
    

    function Listing($formvars = array()) {

        // RECHERCHE
        $form = new BackForm("# TEMOIGNAGE", "text", "t.temoignage_id");
        $form->setVar("compare", "EQUAL");
        $this->addForm($form);

        $form = new BackForm("Produit", "autocomplete", "t.produit_id");
        $form->addAttr('style', 'width:400px');
        $form->setVar('method', '/produit/custom/autocomplete/?produit_nom_nom=');
        $form->setVar('param', 'produit');
        $this->addForm($form);



        $form = new BackForm("Statut", "select", "t.temoignage_statut_id");
        $form->setVar("compare", "EQUAL");
        $form->addOption("", "---");
        $form->addOption("1", "ACTIF");
        $form->addOption("2", "INACTIF");
        $this->addForm($form);
        //-- RECHERCHE
        
        
        
        // SQL
				$sql="SELECT temoignage_id, temoignage_id, t.client_id, pnom.produit_nom_nom, CONCAT(temoignage_etoile_nom_nom,' (',n.temoignage_etoile_valeur,')')";
				$sql.=", DATE_FORMAT(temoignage_date_ajout,'%d-%m-%Y %H:%i:%s')";
				$sql.=", CONCAT('<b>',t.temoignage_titre,'</b><br/>',t.temoignage_texte)";
				$sql.=", t.temoignage_statut_id";
				$sql.= " FROM (temoignage t)";
				$sql.= " LEFT JOIN produit_nom pnom ON (pnom.produit_id=t.produit_id)";
				$sql.= " LEFT JOIN temoignage_etoile n ON (n.temoignage_etoile_id=t.temoignage_etoile_id)";
				$sql.= " LEFT JOIN temoignage_etoile_nom nnom ON (nnom.temoignage_etoile_id=t.temoignage_etoile_id)";
				$sql.= " LEFT JOIN langue l ON (l.langue_id=t.langue_id)";
				$sql.= " WHERE 1";	
				
				if(!empty($formvars['produit'])) $sql.=" AND t.produit_id = '".$formvars['produit']."'";	
		
				//echo $sql;
		
					
				$this->request=$sql;
				//-- SQL
				
				// LABELS
				$label = new BackLabel("ID");
				$this->addLabel($label);
				
				$label = new BackLabel("CLIENT ID");
				$this->addLabel($label);
				
				$label = new BackLabel("PRODUIT");
				$this->addLabel($label);
				
				$label = new BackLabel("VALEUR");
				$this->addLabel($label);
		
				$label = new BackLabel("DATE");
				$this->addLabel($label);
				
				$label = new BackLabel("AVIS");
				$this->addLabel($label);
		
				$label = new BackLabel("VISIBLE", "statut");
        $this->addLabel($label);	

        return $this->displayList($formvars['type']);
    }

    function Form($formvars = array()) {

        if (empty($formvars['id']))
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'un nouveau témoignage</a></span>";
        else {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition du témoignage numéro : <strong>" . $formvars['id'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $this->request = getTable('temoignage', $formvars['id']);
        }
        //-- SQL
        // Champs du formulaire
        //GROUP
        $form = new BackForm("Témoignage", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Produit", "autocomplete", "produit_id");
        $form->addAttr('class', 'required');
        $form->addAttr('style', 'width:400px');
        $form->setVar('method', '/produit/custom/autocomplete/?produit_nom_nom=');
        $form->setVar('param', 'produit');
        $this->addForm($form);

        $form = new BackForm("Id du client", "text", "client_id");
        $this->addForm($form);
        
        $form = new BackForm("Notation","select","temoignage_etoile_id");
				$form->addAttr('class','required');		
				$form->addOptionSQL(array("SELECT n.temoignage_etoile_id, nn.temoignage_etoile_nom_nom FROM temoignage_etoile n, temoignage_etoile_nom nn WHERE n.temoignage_etoile_id = nn.temoignage_etoile_id AND nn.langue_id = '".LANGUE."' ORDER BY langue_id"));
				$this->addForm($form);
        
        $form = new BackForm("Titre", "text", "temoignage_titre");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Pseudo", "text", "temoignage_pseudo");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Temoignage", "tinymce", "temoignage_texte");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Statut", "select", "temoignage_statut_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array("(SELECT 1, 'ACTIF') UNION (SELECT 2, 'INACTIF')"));
        $this->addForm($form);

        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id']);
    }

}