<?php

class bTpe_reference extends BackModule {

    function bTpe_reference($formvars = array()) {
        parent::BackModule($formvars);
        $this->droits['ADD'] = false;
        $this->droits['DEL'] = false;
        $this->droits['MOD'] = false;
    }

    function Listing($formvars = array()) {

        // RECHERCHE
        $form = new BackForm("# Transaction", "text", "cr.tpe_reference_id");
        $this->addForm($form);

        $form = new BackForm("Date Transaction", "date", "cr.tpe_reference_date");
        $this->addForm($form);

        $form = new BackForm("# Commande", "text", "cr.commande_id");
        $this->addForm($form);

        $form = new BackForm("# Client", "text", "cr.client_id");
        $this->addForm($form);
        
        $form = new BackForm("Mode Paiement", "select", "cr.paiement_id");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT paiement_id, paiement_nom_nom FROM paiement_nom WHERE langue_id = '" . LANGUE . "' ORDER BY paiement_nom_nom"));
        $this->addForm($form);
        
        //-- RECHERCHE
        // SQL
        $sql = "SELECT cr.tpe_reference_id, cr.tpe_reference_id, cr.tpe_reference_date, commande_id, cr.client_id, c.client_email, paiement_nom_nom,''";
        $sql.=" FROM (tpe_reference cr)";
        $sql.=" LEFT JOIN paiement_nom pn ON (pn.paiement_id = cr.paiement_id AND pn.langue_id= '".LANGUE."')";
        $sql.=" LEFT JOIN client c ON (c.client_id = cr.client_id)";
        $sql.=" WHERE 1";
        //if(!empty($formvars['zone'])) $sql.=" AND p.zone_id = '".$formvars['zone']."'";


        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("DATE");
        $label->setVar('format', 'date');
        $label->setVar('option', array("%d-%m-%Y - H:i:s"));
        // - %H:%i:%s
        $this->addLabel($label);

        //$label = new BackLabel("COMMANDE" );
        $label = new BackLabel("COMMANDE", 'listselect');
        $label->setVar('option', array("module" => "<a href='../../commande/list/?c*commande_id=%1%'>%IMG%</a>"));
        $this->addLabel($label);

        $label = new BackLabel("CLIENT", 'listselect');
        $label->setVar('option', array("module" => "<a href='../../client/list/?c*client_id=%1%'>%IMG%</a>"));
        $this->addLabel($label);

        $label = new BackLabel("E-MAIL");
        $this->addLabel($label);
        
         $label = new BackLabel("PAIEMENT");
        $this->addLabel($label);

        $label = new BackLabel("DETAILS", 'action');
        $label->setVar('url', "/back/html/tpe_reference_export/custom/details/");
        $label->setVar('texte', '<img src="/back/styles/images/comment.gif" alt="popupajax"/>');
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

}