<?php

namespace Console\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Command\Command;

use RecursiveIteratorIterator;
use RecursiveDirectoryIterator;

/**
 * Ne fonctionne pas
 *
 * Class StoragePermission
 * @package Console\Command
 */
class StoragePermission extends Command
{
    protected function configure()
    {
        $this
            ->setName('storage:permission')
            ->setDescription('met les bons droits / groupe sur le dossier storage');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $dir = SITE_DIR . 'storage/';
        $filemode = 0775;
        $group = 'www-data';

        $iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($dir), RecursiveIteratorIterator::SELF_FIRST);

        foreach($iterator as $item) {
            $itemName = basename($item);
            if ($itemName == '.' || $itemName == '..' || is_dir($item) == false) {
                continue;
            }

            $resultGrp = chgrp($item, $group);
            $resultMod = chmod($item, $filemode);
            if ($resultMod && $resultGrp) {
                $type = 'info';
            } else {
                $type = 'error';
                echo $item . "\n";
            }

            $output->writeln("<$type>$item</$type>");
        }
    }

}