<?php

namespace Event;

use Symfony\Component\EventDispatcher\Event;
use Template;

class TemplateEvent extends Event
{
    const PRE_RENDER = 'template.pre_render';
    const POST_RENDER = 'template.post_render';

    protected $engine;

    public function __construct(Template $engine)
    {
        $this->engine = $engine;
    }

    public function getEngine()
    {
        return $this->engine;
    }
}