<?php

namespace Form\Constraint;

/**
 * Class Not
 * @package Form\Constraint
 */
class Not extends Constraint {
    /**
     * @var
     */
    protected $forbidden;

    /**
     * @param $forbidden
     */
    public function __construct($forbidden)
    {
        parent::__construct();
        $this->forbidden = $forbidden;
    }

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        return $value != $this->forbidden;
    }

}