<?php

namespace Form\Constraint;

/**
 * Class PostalCode
 * @package Form\Constraint
 */
class PostalCode extends Constraint{

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        return ((strlen($value) == 5 && is_numeric($value) && $value < 99999) || (strtoupper($value) == "2A") || (strtoupper($value) == "2B"));
    }

}