
{extends file='layout/layout.tpl'}
{block name='content'}
    <div class="account">
        <div class="container">
            {Breadcrumb::getInstance()->render()}
            {include file="account/top-account.tpl"}

            <div class="account-menu">
                {include file="account/aside.tpl" page="ba"}
            </div>

            <div class="account-panel history">
                <h1 class="bottom-grey-border">{txt value="Mes bons d’achat"}</h1>
                    <table id="commandes" class="table table-responsive">
                        <tr class="head">
                            <th class="command-id-head">{txt value="Nom du bon d\'achat"}</th>
                            <th class="txt-center">{txt value="Montant TTC du Bon d\'achat"}</th>
                            <th class="txt-center">{txt value="La date limite d\'utilisation"}</th>
                            <th class="txt-center">{txt value="L\'état"}</th>
                        </tr>
                        {foreach $bon as $ba}
                            <tr>
                                <td class="command-id">{$ba.bon_achat_nom}</td>
                                <td>{price ttc=$ba.bon_achat_prix}</td>
                                <td>{$ba.bon_achat_date_limit|date_format:"%d/%m/%Y"}</td>
                                {if $ba.bon_achat_statut_id == 1}
                                    <td class="valid">{txt value="Valide"}</td>
                                {else}
                                    <td class="used">{txt value="Utilisé"}</td>
                                {/if}
                            </tr>
                        {foreachelse}
                            <tr>
                                <td colspan="6">{txt value="Aucune bons d\’achat."}</td>
                            </tr>
                        {/foreach}
                    </table>
            </div>
        </div>
    </div>
{/block}
