<?php

class bEmail extends BackModule {

    function bEmail($formvars = array()) {
        parent::BackModule($formvars);
    }

    function update($formvars = array(), $table = null, $langue = true) {
        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true) {
        return parent::create_multi($formvars, $table, $langue);
    }

    function delete($formvars = array(), $table = null, $langue = true) {
        return parent::delete_multi($formvars, $table, $langue);
    }

    function Form($formvars = array()) {

        if (empty($formvars['id']))
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'un nouvel Email</a></span>";
        else {
            $sql = "SELECT email_nom as data FROM email WHERE email_id = '" . $formvars['id'] . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition de l'Email  : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {

            $sql = "SELECT *";
            $sql.=" FROM email e";
            $sql.=" LEFT JOIN email_nom en ON(e.email_id = en.email_id AND en.langue_id = '" . LANGUE . "')";
            $sql.=" WHERE e.email_id='" . $formvars['id'] . "'";
            $this->request = $sql;
        }
        //-- SQL
        // Champs du formulaire
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "email_nom");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Code", "text", "email_code");
        $form->addAttr('class', 'required');
        if (!empty($formvars['id'])) {
            $form->addAttr('readonly', 'readonly');
        }
        $this->addForm($form);

        $form = new BackForm("Decription", "textarea", "email_description");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Statut", "select", "email_statut");
        $form->addAttr('class', 'required');
        $form->addOption('1', 'Activé');
        $form->addOption('0', 'Desactivé');
        $this->addForm($form);

        $form = new BackForm("Email", "group");
        $this->addForm($form);

        $form = new BackForm("Sujet", "text", "email_nom_sujet");
        $form->addAttr('class', 'required');
        $form->setVar('translate', true);
        $this->addForm($form);

        $form = new BackForm("Corps", "tinymce", "email_nom_content");
        $form->addAttr('class', 'required');
        $form->setVar('translate', true);
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array()) {

        $form = new BackForm("Code", "text", "e.email_code");
        $form->setVar('compare', 'LIKE');
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "e.email_nom");
        $form->setVar('compare', 'LIKE');
        $this->addForm($form);

        $sql = "SELECT e.email_id, e.email_id, e.email_code, e.email_nom, e.email_description, en.email_nom_sujet";
        $sql.=", IF(e.email_statut = 1, 'Activé', 'Desactivé')";
        $sql.=" FROM (email e)";
        $sql.=" LEFT JOIN email_nom en ON (e.email_id = en.email_id AND en.langue_id = '" . LANGUE . "')";
        $sql.=" WHERE 1";


        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("CODE");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("DESC");
        $this->addLabel($label);

        $label = new BackLabel("SUJET");
        $this->addLabel($label);

        $label = new BackLabel("STATUT");
        $this->addLabel($label);

        $label = new BackLabel("TRADUCTIONS", 'translate');
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

//--
}

?>