﻿<?php

class bTableau_bord extends BackModule {

    var $dataGraph;
    // donn�es pour le graph
    var $itemGraph = array();
    // donn�es pour le graph
    var $formvars;
    // donn�es de recherce
    var $sessionName; // objet en session

    function bTableau_bord($formvars = array()) {
        parent::BackModule($formvars);

        $this->droits['MOD'] = false;
    }

    function Listing($formvars = array()) {
        
        if (!$this->droits['READ']) {
            header('Location: /back/');
            exit;
            //exit;
        }
        $out = "";

        //Fil d'ariane --
        $out .= "<div id='path'>
			<span>
				<a href='/back/'>
					<img alt='home_btn' src='/back/styles/images/tableau.png' />
				</a>&nbsp;
			</span>
			<span>&raquo;
				<a href='/back/html/tableau_bord/list/'>
					Tableau de bord
				</a>
			</span>
		</div>";
        // -- Fil d'araine
        // Titre --
        $out .= "<div id='title'>
			<h1>Tableau de bord</h1>
		</div>";
        // -- Titre
        // CSV --
        $out .= "<div class='records_view_options export_tdb'>
		      <dl>
		        <dt> Action &rsaquo; </dt>
		        <dd>

		          <ul>
		            <li title='Informations::Export du listing en CSV' class='infobulle pie_view_option_CSV'> <div class='overlay_export_bg'></div><div class='overlay_export'>CSV</div> <a class='f_pie_view_option' href='/back/html/tableau_bord/export/csv/'> CSV </a> </li>
		          </ul>
		        </dd>
		      </dl></div>
		    <div class='clear'></div>		    
		  </div>";

        // -- CSV
        // Conenue --

        $out .= "<div>
			<div class='table'>
				<table style='margin:0;float: left;height: 100%;' id='records_top' class='records'>
					<tbody>
						<tr>
							<td class='table_controls'>";


        // Colonne de gauche --

        $out .= "<div id='searchGraphList' class='records' >
                    <table class='records left_tableau_de_bord'>
			<tr class='ltdb'>
                            <td class='ltdb'>";



        // --REQUETE NB COMMANDE
        //aujourd'hui
        $sql = "SELECT COUNT(commande_id) as nb_commande";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];



        //hier
        $sql = "SELECT COUNT(commande_id) as nb_commande";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = (CURRENT_DATE() - INTERVAL 1 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $hier = $this->sql->record[0];




        //30 dernier jours
        $sql = "SELECT COUNT(commande_id) as nb_commande";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) >= (CURRENT_DATE() - INTERVAL 30 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $mois = $this->sql->record[0];

        // REQUETE NB COMMANDE--
        //Bloc recapitulatif --

        $out .= "<table class='bloc-recapitulatif'>";

        // Titre Bloc recapitulatif --
        $out .= "<tr><th>";
        $out .= "Nombres de commandes";
        $out.= "</th></tr>";
        // -- Titre bloc recapitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance1'>";
        $out .= "Aujourd'hui : <span>" . $aujourdhui['nb_commande'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance2'>";
        $out .= "Hier : <span>" . $hier['nb_commande'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance3'>";
        $out .= "Les 30 derniers jours : <span>" . $mois['nb_commande'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif

        $out .= "</table>";

        // -- Bloc recapitulatif
        // --REQUETE CA
        //aujourd'hui
        $sql = "SELECT ROUND(SUM(commande_total_ht),2) as ca";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];



        //hier
        $sql = "SELECT ROUND(SUM(commande_total_ht),2) as ca";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = (CURRENT_DATE() - INTERVAL 1 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $hier = $this->sql->record[0];




        //30 dernier jours
        $sql = "SELECT ROUND(SUM(commande_total_ht),2) as ca";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) >= (CURRENT_DATE() - INTERVAL 30 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $mois = $this->sql->record[0];

        // REQUETE CA--
        //Bloc recapitulatif --

        $out .= "<table class='bloc-recapitulatif'>";

        // Titre Bloc recapitulatif --
        $out .= "<tr><th>";
        $out .= "CA";
        $out.= "</th></tr>";
        // -- Titre bloc recapitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance1'>";
        if ($aujourdhui['ca']) {
            $out .= "Aujourd'hui : <span>" . $aujourdhui['ca'] . " &euro;</span>";
        } else {
            $out .= "Aujourd'hui : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance2'>";
        if ($hier['ca']) {
            $out .= "Hier : <span>" . $hier['ca'] . " &euro;</span>";
        } else {
            $out .= "Hier : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance3'>";
        if ($mois['ca']) {
            $out .= "Les 30 derniers jours : <span>" . $mois['ca'] . " &euro;</span>";
        } else {
            $out .= "Les 30 derniers jours : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif

        $out .= "</table>";

        // -- Bloc recapitulatif
        // --REQUETE PANIER MOYEN
        //aujourd'hui
        $sql = "SELECT ROUND(SUM(commande_stotal_ht)/COUNT(commande_id),2) as pm";
        $sql.=" FROM commande c";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];



        //hier
        $sql = "SELECT ROUND(SUM(commande_stotal_ht)/COUNT(commande_id),2) as pm";
        $sql.=" FROM commande c";
        $sql.=" WHERE DATE(commande_date_ajout) = (CURRENT_DATE() - INTERVAL 1 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $hier = $this->sql->record[0];




        //30 dernier jours
        $sql = "SELECT ROUND(SUM(commande_stotal_ht)/COUNT(commande_id),2) as pm";
        $sql.=" FROM commande c";
        $sql.=" WHERE DATE(commande_date_ajout) >= (CURRENT_DATE() - INTERVAL 30 DAY ) ";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $mois = $this->sql->record[0];

        // REQUETE CA--
        //Bloc recapitulatif --

        $out .= "<table class='bloc-recapitulatif'>";

        // Titre Bloc recapitulatif --
        $out .= "<tr><th>";
        $out .= "PANIER MOYEN HT (hors fdp)";
        $out.= "</th></tr>";
        // -- Titre bloc recapitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance1'>";
        if ($aujourdhui['pm']) {
            $out .= "Aujourd'hui : <span>" . $aujourdhui['pm'] . " &euro;</span>";
        } else {
            $out .= "Aujourd'hui : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance2'>";
        if ($hier['pm']) {
            $out .= "Hier : <span>" . $hier['pm'] . " &euro;</span>";
        } else {
            $out .= "Hier : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance3'>";
        if ($mois['pm']) {
            $out .= "Les 30 derniers jours : <span>" . $mois['pm'] . " &euro;</span>";
        } else {
            $out .= "Les 30 derniers jours : <span>0 &euro;</span>";
        }
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif

        $out .= "</table>";

        // -- Bloc recapitulatif
        // --REQUETE NOUVEAUX CLIENTS
        //aujourd'hui
        $sql = "SELECT COUNT(client_id) as nb_client";
        $sql.=" FROM client";
        $sql.=" WHERE DATE(client_date_ajout) = CURRENT_DATE()";
        $sql.=" AND client_statut_id = 1";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];



        //hier
        $sql = "SELECT COUNT(client_id) as nb_client";
        $sql.=" FROM client";
        $sql.=" WHERE DATE(client_date_ajout) = (CURRENT_DATE() - INTERVAL 1 DAY)  ";
        $sql.=" AND client_statut_id = 1";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $hier = $this->sql->record[0];




        //30 dernier jours
        $sql = "SELECT COUNT(client_id) as nb_client";
        $sql.=" FROM client";
        $sql.=" WHERE DATE(client_date_ajout) >= (CURRENT_DATE() - INTERVAL 30 DAY ) ";
        $sql.=" AND client_statut_id = 1";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $mois = $this->sql->record[0];

        // REQUETE NOUVEAUX CLIENTS--
        //Bloc recapitulatif --

        $out .= "<table class='bloc-recapitulatif'>";

        // Titre Bloc recapitulatif --
        $out .= "<tr><th>";
        $out .= "Nouveaux clients";
        $out.= "</th></tr>";
        // -- Titre bloc recapitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance1'>";
        $out .= "Aujourd'hui : <span>" . $aujourdhui['nb_client'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance2'>";
        $out .= "Hier : <span>" . $hier['nb_client'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif
        // Ligne Bloc recapitulatif --
        $out .= "<tr><td class='importance3'>";
        $out .= "Les 30 derniers jours : <span>" . $mois['nb_client'] . "</span>";
        $out.= "</td></tr>";
        // -- Ligne Bloc recalitulatif

        $out .= "</table>";

        // -- Bloc recapitulatif

        $out .= "               </td>
                            </tr>
                        </table>
                        
                   </div>";

        // -- Colonne de gauche
        // Contenue de droite --
        // Formulaire --

        $out .= "<div class='box formulaire_tableau_de_bord'>";
        $out .= "<form id='form1' action='/back/html/tableau_bord/list/' name='form1' method='get'>";
        $out .= "<div class='form_obligatoire'>";
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Par";
        $out .= "</label>";

        // valeur par defaut
        if (!isset($_GET['group']))
            $_GET['group'] = 'day';

        $out .= "<select name='group'>";
        if ($_GET["group"] == 'day') {
            $out .= "<option selected='selected' value='day'>Jour</option>";
        } else {
            $out .= "<option value='day'>Jour</option>";
        }
        if ($_GET["group"] == 'week') {
            $out .= "<option selected='selected' value='week'>Semaine</option>";
        } else {
            $out .= "<option value='week'>Semaine</option>";
        }
        if ($_GET["group"] == 'month') {
            $out .= "<option selected='selected' value='month'>Mois</option>";
        } else {
            $out .= "<option value='month'>Mois</option>";
        }
        if ($_GET["group"] == 'quarter') {
            $out .= "<option selected='selected' value='quarter'>Trimestre</option>";
        } else {
            $out .= "<option value='quarter'>Trimestre</option>";
        }
        if ($_GET["group"] == 'year') {
            $out .= "<option selected='selected' value='year'>Année</option>";
        } else {
            $out .= "<option value='year'>Année</option>";
        }
        if ($_GET["group"] == 'produit') {
            $out .= "<option selected='selected' value='produit'>Produit</option>";
        } else {
            $out .= "<option value='produit'>Produit</option>";
        }
        if ($_GET["group"] == 'produit_attribut') {
            $out .= "<option selected='selected' value='produit_attribut'>Produit attribut</option>";
        } else {
            $out .= "<option value='produit_attribut'>Produit attribut</option>";
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Date";
        $out .= "</label>";

        // valeur par defaut
        if (!isset($_GET['select_date']))
            $_GET['select_date'] = 'cmd';

        $out .= "<select name='select_date'>";
        if ($_GET["select_date"] == 'cmd') {
            $out .= "<option selected='selected' value='cmd'>Date de commande</option>";
        } else {
            $out .= "<option value='cmd'>Date de commande</option>";
        }
        if ($_GET["select_date"] == 'fact') {
            $out .= "<option selected='selected' value='fact'>Date de facturation</option>";
        } else {
            $out .= "<option value='fact'>Date de facturation</option>";
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec champ date) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "du";
        $out .= "</label>";
        if (!isset($_GET["date"][0])) {
            $date_debut = date('d/m/Y', time() - 30 * 24 * 3600);
        } else {
            $date_debut = $_GET["date"][0];
        }

        $out .= "<img id='date_debut_img' title='Date selector' src='/back/styles/images/calendar.gif' alt='choix_calendar' />";
        $out .= "<input value='" . $date_debut . "' type='text' id='date_debut' name='date[]' class='validate-date-au' title='Le champ Date doit avoir ce format JJ/MM/AAAA exemple: 02/12/1983 pour le 2 D&eacute;cembre 1983' maxlength='10' size='10'/>";
        $out .= "<script type='text/javascript'>";
        $out .= "Calendar.setup(
                    {
                        inputField  : 'date_debut',
			ifFormat    : '%d/%m/%Y',
			button      : 'date_debut_img'
                    }
		);
		</script>";

        if (!isset($_GET["date"][1])) {
            $date_fin = date('d/m/Y');
        } else {
            $date_fin = $_GET["date"][1];
        }

        $out .= "<label>";
        $out .= "au";
        $out .= "</label>";
        $out .= "<img id='date_fin_img' title='Date selector' src='/back/styles/images/calendar.gif' alt='choix_calendar' />";
        $out .= "<input id='date_fin' name='date[]' value='" . $date_fin . "' type='text' class='validate-date-au' title='Le champ Date doit avoir ce format JJ/MM/AAAA exemple: 02/12/1983 pour le 2 D&eacute;cembre 1983' maxlength='10' size='10'/>";
        $out .= "<script type='text/javascript'>";
        $out .= "Calendar.setup(
                    {
                        inputField  : 'date_fin',
			ifFormat    : '%d/%m/%Y',
			button      : 'date_fin_img'
                    }
		);
		</script>";

        $out .= "</p>";
        // -- Un champ de recherche (avec champ date)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Avoir le";
        $out .= "</label>";

        // valeur par defaut
        if (!isset($_GET['item']) || ($_GET['item'][0] == 'nb_client' && $_GET['group'] == 'produit') || ($_GET['item'][0] == 'nb_client' && $_GET['group'] == 'produit_attribut'))
            $_GET['item'][0] = 'ca_ht';

        $out .= "<select name='item[]' size='3' multiple='multiple'>";
        if (isset($_GET["item"]) && in_array('ca_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='ca_ht'>Chiffre d'affaire HT</option>";
        } else {
            $out .= "<option value='ca_ht'>Chiffre d'affaire HT</option>";
        }
        if (isset($_GET["item"]) && in_array('ca_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='ca_ttc'>Chiffre d'affaire TTC</option>";
        } else {
            $out .= "<option value='ca_ttc'>Chiffre d'affaire TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('sca_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='sca_ht'>Chiffre d'affaire HT (hors frais de port)</option>";
        } else {
            $out .= "<option value='sca_ht'>Chiffre d'affaire HT (hors frais de port)</option>";
        }
        if (isset($_GET["item"]) && in_array('sca_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='sca_ttc'>Chiffre d'affaire TTC (hors frais de port)</option>";
        } else {
            $out .= "<option value='sca_ttc'>Chiffre d'affaire TTC (hors frais de port)</option>";
        }
        if (isset($_GET["item"]) && in_array('fdp_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='fdp_ht'>Frais de port HT</option>";
        } else {
            $out .= "<option value='fdp_ht'>Frais de port HT</option>";
        }
        if (isset($_GET["item"]) && in_array('fdp_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='fdp_ttc'>Frais de port TTC</option>";
        } else {
            $out .= "<option value='fdp_ttc'>Frais de port TTC</option>";
        }
        //En attente
        if (isset($_GET["item"]) && in_array('marge_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='marge_ht'>Marge HT</option>";
        } else {
            $out .= "<option value='marge_ht'>Marge HT</option>";
        }
        if (isset($_GET["item"]) && in_array('marge_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='marge_ttc'>Marge TTC</option>";
        } else {
            $out .= "<option value='marge_ttc'>Marge TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_commande', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_commande'>Nombre de commandes</option>";
        } else {
            $out .= "<option value='nb_commande'>Nombre de commandes</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_produit', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_produit'>Nombre de produits commandés</option>";
        } else {
            $out .= "<option value='nb_produit'>Nombre de produits commandés</option>";
        }
        if (isset($_GET["item"]) && in_array('promo_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='promo_ht'>Cout promo HT</option>";
        } else {
            $out .= "<option value='promo_ht'>Cout promo HT</option>";
        }
        if (isset($_GET["item"]) && in_array('promo_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='promo_ttc'>Cout promo TTC</option>";
        } else {
            $out .= "<option value='promo_ttc'>Cout promo TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_promos', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_promos'>Nombres de promo utilisés</option>";
        } else {
            $out .= "<option value='nb_promos'>Nombres de promo utilisés</option>";
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        $out .= '</div>';

        // Force le passage à la ligne --
        $out .= " <hr class='clear' />";
        // -- Force le passage à la ligne
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Categorie";
        $out .= "</label>";
        $out .= "<select name='categorie_id[]' size='3' multiple='multiple'>";
        $parent = "SELECT c.categorie_id, cn.categorie_nom_nom FROM (categorie c,categorie_nom cn) WHERE parent_id IS NULL AND cn.langue_id='" . LANGUE . "' AND c.categorie_id=cn.categorie_id ORDER BY categorie_nom_nom";
        $this->sql->query($parent, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) { //Liste les categorie parent
            if (isset($_GET["categorie_id"]) && in_array($row[0], $_GET["categorie_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
            $categorie = "SELECT c.categorie_id, cn.categorie_nom_nom FROM (categorie c,categorie_nom cn) WHERE cn.langue_id='" . LANGUE . "' AND c.categorie_id=cn.categorie_id AND c.parent_id = " . $row[0] . " ORDER BY categorie_nom_nom";
            $this->sql->query($categorie, SQL_ALL, SQL_INDEX);
            $rows2 = $this->sql->record;
            foreach ($rows2 as $row2) {//Liste les categorie enfant
                if (isset($_GET["categorie_id"]) && in_array($row2[0], $_GET["categorie_id"])) {
                    $out .= "<option selected='selected' value='" . $row2[0] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $row2[1] . "</option>";
                } else {
                    $out .= "<option value='" . $row2[0] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $row2[1] . "</option>";
                }
            }
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Gamme";
        $out .= "</label>";
        $out .= "<select name='gamme_id[]' size='3' multiple='multiple'>";
        $gamme = "SELECT c.gamme_id, cn.gamme_nom_nom FROM (gamme c,gamme_nom cn) WHERE cn.langue_id='" . LANGUE . "' AND c.gamme_id=cn.gamme_id ORDER BY gamme_nom_nom";
        $this->sql->query($gamme, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les gammes
            if (isset($_GET["gamme_id"]) && in_array($row[0], $_GET["gamme_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Double champ de recherche (avec input text) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Ref produit";
        $out .= "</label>";
        if (isset($_GET["produit_ref"])) {//Tri par reference produit du client
            $out .= "<input value='" . $_GET["produit_ref"] . "' name='produit_ref'  maxlength='20' size='20'/>";
        } else {
            $out .= "<input name='produit_ref'  maxlength='20' size='20'/>";
        }

        $out .= "<label>";
        $out .= "Ref Frs produit";
        $out .= "</label>";
        if (isset($_GET["produit_ref_frs"])) {//Tri par reference produit du fournisseur
            $out .= "<input value='" . $_GET["produit_ref_frs"] . "' name='produit_ref_frs'  maxlength='20' size='20'/>";
        } else {
            $out .= "<input name='produit_ref_frs'  maxlength='20' size='20'/>";
        }
        $out .= "</p>";
        // -- Double champ de recherche (avec input text)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Marque";
        $out .= "</label>";
        $out .= "<select name='marque_id[]' size='3' multiple='multiple'>";
        $marque = "SELECT m.marque_id, m.marque_nom FROM (marque m) ORDER BY marque_nom";
        $this->sql->query($marque, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les marques pour le tri
            if (isset($_GET["marque_id"]) && in_array($row[0], $_GET["marque_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Fournisseurs";
        $out .= "</label>";
        $out .= "<select name='fournisseur_id[]' size='3' multiple='multiple'>";
        $fournisseur = "SELECT f.fournisseur_id, f.fournisseur_nom FROM (fournisseur f) ORDER BY fournisseur_nom";
        $this->sql->query($fournisseur, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les fournisseurs pour le tri
            if (isset($_GET["fournisseur_id"]) && in_array($row[0], $_GET["fournisseur_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<p>";
        $out .= "<label>";
        $out .= "Mode de paiement";
        $out .= "</label>";
        $out .= "<select name='paiement_id[]' size='3' multiple='multiple'>";
        $paiement = "SELECT p.paiement_id, pn.paiement_nom_nom FROM (paiement p) LEFT JOIN (paiement_nom pn) ON (p.paiement_id=pn.paiement_id)  ORDER BY pn.paiement_nom_nom";
        $this->sql->query($paiement, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les mode de paiement
            if (isset($_GET["paiement_id"]) && in_array($row[0], $_GET["paiement_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</p>";
        // -- Un champ de recherche (avec select)




        $out .= "<div class='bouton_formulaire_tableau_de_bord'>
                    <p class='SubmitP'>
                        <input type='submit' value='Appliquer' />
                    </p>
                </div>";


        $out .="</form>";
        $out .= "</div>";






    // CAS DE LA RECHERCHE PAR categorie_id
				

        //-- RECHERCHE

       $searchSPEC = false;

				// CAS DE LA RECHERCHE PAR categorie_id
				if (!empty($_GET['categorie_id'][0])) {
					$searchProduit = array(-1);
					foreach($_GET['categorie_id'] as $zeCat) {
						$sql="SELECT produit_id FROM produit_categorie pc";
						$sql.=" LEFT JOIN categorie c ON (c.categorie_id = pc.categorie_id)";
						$sql.=" WHERE c.categorie_id = '".$zeCat."' OR c.parent_id = '".$zeCat."'";
						$this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arrProd = $this->sql->record;
            foreach($arrProd as $p) {
            	array_push($searchProduit,$p['produit_id']);
            }
            $searchProduit = array_unique($searchProduit);
					}
					$searchSPEC = true;
				}
				
				if (!empty($_GET['gamme_id'][0])) {
            $searchProduitGamme = array(-1);
					foreach($_GET['gamme_id'] as $zeGamme) {
						$sql="SELECT produit_id FROM produit_gamme pg";
						$sql.=" WHERE pg.gamme_id = '".$zeGamme."'";
						$this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arrProd = $this->sql->record;
            foreach($arrProd as $p) {
            	array_push($searchProduitGamme,$p['produit_id']);
            }
            $searchProduitGamme = array_unique($searchProduitGamme);
					}
					$searchSPEC = true;
        }
        
        if (!empty($_GET['marque_id'][0])) {
            $searchProduitMarque = array(-1);
					foreach($_GET['marque_id'] as $zeMarque) {
						$sql="SELECT produit_id FROM produit p";
						$sql.=" WHERE p.marque_id = '".$zeMarque."'";
						$this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arrProd = $this->sql->record;
            foreach($arrProd as $p) {
            	array_push($searchProduitMarque,$p['produit_id']);
            }
            $searchProduitMarque = array_unique($searchProduitMarque);
					}
					$searchSPEC = true;
        }
        
        if (!empty($_GET['fournisseur_id'][0])) {
            $searchProduitFrs = array(-1);
					foreach($_GET['fournisseur_id'] as $zeFrs) {
						$sql="SELECT produit_id FROM produit p";
						$sql.=" WHERE p.fournisseur_id = '".$zeFrs."'";
						$this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arrProd = $this->sql->record;
            foreach($arrProd as $p) {
            	array_push($searchProduitFrs,$p['produit_id']);
            }
            $searchProduitFrs = array_unique($searchProduitFrs);
					}
					$searchSPEC = true;
        }

        //-- RECHERCHE

        if (!isset($_GET['date'][0]))
            $_GET['date'][0] = date('d/m/Y', time() - 30 * 24 * 3600);
        if (!isset($_GET['date'][1]))
            $_GET['date'][1] = date('d/m/Y');
        if (!isset($_GET['group']))
            $_GET['group'] = "day";
        if (!isset($_GET['item']))
            $_GET['item'] = array("ca_ht");
        if (!isset($_GET['select_date']))
            $_GET['select_date'] = "cmd";
        
        switch ($_GET['select_date']) {

            case 'fact':
                $tri_date = 'c.commande_facture_date';
                break;

            default:
                $tri_date = 'c.commande_date_ajout';
                break;
        }
				
        if (!empty($_GET['date'][0])) {
            list($d, $m, $y) = explode("/", $_GET['date'][0]);
            $_GET['date_debut'] = $y . "-" . $m . "-" . $d;
        }
        if (!empty($_GET['date'][1])) {
            list($d, $m, $y) = explode("/", $_GET['date'][1]);
            $_GET['date_fin'] = $y . "-" . $m . "-" . $d;
        }

        switch ($_GET['group']) {

            case 'week':
                $group = 'YEARWEEK(' . $tri_date . ',1) as group_date, CONCAT("Semaine " ,WEEK(' . $tri_date . ',1)," - ",YEAR(' . $tri_date . ')) as libelle';
                break;

            case 'month':
                $group = 'CONCAT(YEAR(' . $tri_date . '),MONTH(' . $tri_date . ')) as group_date, DATE_FORMAT(' . $tri_date . ',"%m-%Y") as libelle';
                break;

            case 'quarter':
                $group = 'CONCAT(YEAR(' . $tri_date . '),QUARTER(' . $tri_date . ')) as group_date, CONCAT("Trimestre ",QUARTER(' . $tri_date . ')," - ",YEAR(' . $tri_date . ')) as libelle';
                break;

            case 'year':
                $group = 'YEAR(' . $tri_date . ') as group_date, DATE_FORMAT(' . $tri_date . ',"%Y") as libelle';
                break;

            case 'produit':
                $group = " p.produit_id as group_date, produit_nom as libelle";
                break;
            case 'produit_attribut':
                $group = "  IF(cpa.produit_attribut_id,CONCAT(p.produit_id,'-',cpa.produit_attribut_id),p.produit_id) as group_date, IF(cpa.produit_attribut_id,CONCAT(produit_nom,' ',produit_option_nom,' ',produit_option_valeur_nom),produit_nom) as libelle";
                break;

            default:
                $group = 'DATE(' . $tri_date . ') as group_date, DATE_FORMAT(' . $tri_date . ',"%d-%m-%Y") as libelle';
                break;
        }

        $sql = "SELECT " . $group;
        $i = 1;
        $nbitem = count($_GET["item"]);
        foreach ($_GET['item'] as $item) {

            switch ($item) {

                case 'ca_ht':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true)
                   		$sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)),2) as result" . $i;
                   	else
                   		$sql .= ", ROUND(SUM(c.commande_total_ht),2) as result" . $i;
                    break;

                case 'ca_ttc':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true)
                   		$sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)),2) as result" . $i;
                   	else
                    	$sql .= ", ROUND(SUM(c.commande_total_ttc),2) as result" . $i;
                    break;

                case 'sca_ht':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire HT (Hors frais de port)";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true)
                   		$sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)),2) as result" . $i;
                   	else
                    	$sql .= ", ROUND(SUM(c.commande_stotal_ht),2) as result" . $i;
                    break;

                case 'sca_ttc':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire TTC (Hors frais de port)";
                    $this->itemGraph[$i]['type'] = "euro";
                     if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true)
                   		$sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)),2) as result" . $i;
                   	else
                    	$sql .= ", ROUND(SUM(c.commande_stotal_ttc),2) as result" . $i;
                    break;

                case 'fdp_ht':
                    $this->itemGraph[$i]['title'] = "Frais de port HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit')
                   		$sql .= ", 0 as result" . $i;
                   	elseif($_GET['group']=='produit_attribut')
                   		$sql .= ", 0 as result" . $i;
                   	elseif($searchSPEC==true)
                   		$sql .= ", 0 as result" . $i;
                   	else
                    	$sql .= ", ROUND(SUM(c.commande_port_ht),2) as result" . $i;
                    break;

                case 'fdp_ttc':
                    $this->itemGraph[$i]['title'] = "Frais de port TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit')
                   		$sql .= ", 0 as result" . $i;
                   	elseif($_GET['group']=='produit_attribut')
                   		$sql .= ", 0 as result" . $i;
                   	elseif($searchSPEC==true)
                   		$sql .= ", 0 as result" . $i;
                   	else
                   		$sql .= ", ROUND(SUM(c.commande_port_ttc),2) as result" . $i;
                    break;

                case 'marge_ttc':
                    $this->itemGraph[$i]['title'] = "Marge TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    $sql.=", ROUND(SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*(1 + cp.produit_taxe)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*(1 + cp.produit_taxe)*cp.produit_quantite)),2) as result" . $i;
                    break;

                case 'marge_ht':
                		$this->itemGraph[$i]['title'] = "Marge HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    $sql.=", ROUND(SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*cp.produit_quantite)),2) as result" . $i;
                    break;
                    

                case 'nb_commande':
                    $this->itemGraph[$i]['title'] = "Nb commandes";
                    $this->itemGraph[$i]['type'] = "nb";
                    $sql .= ", COUNT(DISTINCT c.commande_id) as result" . $i;
                    break;

                case 'nb_produit':
                    $this->itemGraph[$i]['title'] = "Nb de produits commandés";
                    $this->itemGraph[$i]['type'] = "nb";
                   	 	$sql.=", SUM(IF(cpa.produit_option_valeur_prix<0,0,cpa.produit_option_valeur_quantite)) as result" . $i;
                    break;

                case 'nb_promos':
                    $this->itemGraph[$i]['title'] = "Nb de promotions utilisées";
                    $this->itemGraph[$i]['type'] = "nb";
                    $sql .= ", SUM(IF(cp.produit_prix>0,0,cp.produit_quantite)) as result" . $i;
                    break;

                case 'promo_ht':
                    $this->itemGraph[$i]['title'] = "Cout des promotions HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    $sql .= ", ROUND(SUM(IF(cp.produit_prix>0,0,cp.produit_total_ht*-1)),2) as result" . $i;
                    break;

                case 'promo_ttc':
                    $this->itemGraph[$i]['title'] = "Cout des promotions TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    $sql .= ", ROUND(SUM(IF(cp.produit_prix>0,0,cp.produit_total_ttc*-1)),2) as result" . $i;
                    break;
            }
            $i++;
        }


        $sql.=", " . $tri_date . " as indice";
        $sql .= " FROM commande c";
        
				// BEN
        if (isset($_GET["item"]) && (in_array('marge_ttc', $_GET["item"]) || in_array('marge_ht', $_GET["item"]) || in_array('nb_produit', $_GET["item"]))|| $_GET['group'] == 'produit' || $_GET['group'] == 'produit_attribut' || !empty($_GET['gamme_id'][0]) || !empty($_GET['categorie_id'][0]) || !empty($_GET['marque_id'][0]) || !empty($_GET['fournisseur_id'][0]) || (isset($_GET["echantillon_id"]) && (in_array('0', $_GET["echantillon_id"]))) || (isset($_GET["echantillon_id"]) && (in_array('1', $_GET["echantillon_id"]))) ) {
        	$sql.=" LEFT JOIN (commande_produit cp) ON (c.commande_id=cp.commande_id)";
        	
          $sql.=" LEFT JOIN (commande_produit_attribut cpa) ON (cp.commande_produit_id=cpa.commande_produit_id)";
        } 


        if ($_GET['group'] == 'produit_attribut' || $_GET['group'] == 'produit') {
            $sql.=" LEFT JOIN (produit p) ON (p.produit_id=cp.produit_id)";
        }
        





        // JOINTURE POUR LES FILTRES --
        $date = explode('/', $date_debut);
        $date_debut = $date[2] . "-" . $date[1] . "-" . $date[0];

        $date = explode('/', $date_fin);
        $date_fin = $date[2] . "-" . $date[1] . "-" . $date[0];

        $sql .= " WHERE commande_statut_id != 99 ";
        if ($_GET['group'] == 'produit' || $_GET['group'] == 'produit_attribut') {
            $sql.=" AND p.produit_id IS NOT NULL ";
        }
        $sql .= " AND DATE(" . $tri_date . ") >= '" . $date_debut . "' ";
        $sql .= " AND DATE(" . $tri_date . ") <= '" . $date_fin . "' ";

        // -- TRAITEMENT DES FILTRE
        // Gestion du produit Ref
        if (!empty($_GET['produit_ref'])) {
            $sql .= " AND cp.produit_ref = '" . $_GET['produit_ref'] . "' ";
        }

        // Gestion du produit Ref
        if (!empty($_GET['produit_ref_frs'])) {
            $sql .= " AND cp.produit_ref_frs = '" . $_GET['produit_ref_frs'] . "' ";
        }
				
        if(!empty($searchProduit) && count($searchProduit)>0) {
        	$sql .= " AND cp.produit_id IN (".implode(",",$searchProduit).")";
        }

        if(!empty($searchProduitGamme) && count($searchProduitGamme)>0) {
            $sql .= " AND cp.produit_id IN (".implode(",",$searchProduitGamme).")";
        }
        if(!empty($searchProduitMarque) && count($searchProduitMarque)>0) {
            $sql .= " AND cp.produit_id IN (".implode(",",$searchProduitMarque).")";
        }
        if(!empty($searchProduitFrs) && count($searchProduitFrs)>0) {
            $sql .= " AND cp.produit_id IN (".implode(",",$searchProduitFrs).")";
        }

        if (!empty($_GET['paiement_id'])) {
            $sql .= " AND ( 1 = 2 ";
            foreach ($_GET['paiement_id'] as $paiement) {
                $sql .= " OR c.paiement_id = " . $paiement . " ";
            }

            $sql .= ") ";
        }
        if (!empty($_GET['pays_id'])) {
        	
            $sql .= " AND ( 1 = 2 ";
            foreach ($_GET['pays_id'] as $pays) {
                $sql .= " OR c.livraison_pays_id = " . $pays . " ";
            }

            $sql .= ") ";
        }
        
        
        // TRAITEMENT DES FILTRE --


        

	      	$sql .= " GROUP BY group_date";
/*
if($_SERVER['REMOTE_ADDR'] == '192.168.0.105')
					echo $sql.'<br/><br/>';
	     
*/

        if ($_GET["group"] == 'produit' || $_GET["group"] == 'produit_attribut') { //Pour gérer les problème de offset
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arr = $this->sql->record;
            $arrData = Array();
            foreach ($arr as $value) {
            		if(strpos($value['group_date'],'-')) {
            			//list($ProdAtt,$surmesure) = explode('s',$value['group_date']);
            			list($zeProdId,$zeAttId) = explode('-',$value['group_date']);
            			$sqlN="SELECT CONCAT('#',pn.produit_id,'-',pa.produit_attribut_id,' - ',produit_nom_nom, ' - ',IF(pon1.produit_option_valeur_nom,pon1.produit_option_valeur_nom,''),' ',IF(pon2.produit_option_valeur_nom,pon2.produit_option_valeur_nom,'')) as nom";
            			$sqlN.=" FROM produit_nom pn";
            			$sqlN.=" LEFT JOIN produit_attribut pa ON ( pn.produit_id = pa.produit_id AND pa.produit_attribut_id = '".$zeAttId."')";
            			$sqlN.=" LEFT JOIN produit_option_valeur_nom pon1 ON (pon1.produit_option_valeur_id = pa.produit_option_valeur_id AND pon1.langue_id = 1)";
            			$sqlN.=" LEFT JOIN produit_option_valeur_nom pon2 ON (pon2.produit_option_valeur_id = pa.produit_option_valeur_id_bis AND pon2.langue_id = 1)";
            			$sqlN.=" WHERE pn.langue_id = 1 AND pn.produit_id = '".$zeProdId."'";
            			$this->sql->query($sqlN, SQL_INIT, SQL_ASSOC);
            			$value['libelle'] = $this->sql->record['nom'];
            		}
            		else {
            			//list($zeProdId,$surmesure) = explode('s',$value['group_date']);
            			$zeProdId = $value['group_date'];
            			$sqlN="SELECT CONCAT('#',produit_id,' - ',produit_nom_nom) as nom";
            			$sqlN.=" FROM produit_nom";
            			$sqlN.="  WHERE langue_id = 1 AND produit_id = '".$zeProdId."'";
            			$this->sql->query($sqlN, SQL_INIT, SQL_ASSOC);
            			$value['libelle'] = $this->sql->record['nom'];
            		}
            		/*if($surmesure==1) {
            			$value['libelle'] .= " Sur Mesure";
            		}*/
                $arrData[strip_tags($value['libelle'])][0] = $value['group_date'];
                for ($j = 1; $j < $i; $j++) {
                    $nom = 'result' . $j;
                    if ($value[$nom] != '0')
                        $arrData[strip_tags($value['libelle'])][$j] = $value[$nom];
                }
            }

            $sql = "";
            foreach ($arrData as $key => $data) {
                if (!empty($sql))
                    $sql.=" UNION ";
                $key = str_replace("'","",$key);
                $key = str_replace("\"","",$key);
                $sql.="(SELECT '" . $data[0] . "' as group_date, '" . addslashes($key) . "' as libelle";
                for ($j = 1; $j < $i; $j++) {
                    if (empty($data[$j]))
                        $sql.=", '0' as result" . $j;
                    else
                        $sql.=", '" . addslashes($data[$j]) . "' as result" . $j;
                }
                $sql.=")";
            }
        }
        $this->request = $sql;
        //echo $sql.'<br/><br/>';
        $title_csv = Array();

        // LABELS
        $label = new BackLabel("DATE");
        $label->setVar('order', false);
        $this->addLabel($label);
				$title_csv[] = "DATE";
				
        for ($k = 1; $k < $i; $k++) {
            $label = new BackLabel($this->itemGraph[$k]['title']);
            $label->setVar('order', false);
            $this->addLabel($label);
            $title_csv[] = $this->itemGraph[$k]['title'];
        }
        //-- LABELS
        
        
        $this->formvars = $_GET;
        $this->dataGraph = $this->getData();
				
				$_SESSION['title_csv'] = $title_csv;
				$_SESSION['sql_csv'] = $sql;
				

        $xml = $this->getXML();


        // RECHERCHE --
        // -- Formulaire
        // Tableau de bord --

        $out.='<!-- amline script-->
            <div class="box" style="width:80%">
			  <script type="text/javascript" src="' . SITE_URL . 'js/amline/swfobject.js"></script>
				<div id="flashcontent">
					<strong>You need to upgrade your Flash Player</strong>
				</div>
			
				<script type="text/javascript">
					// <![CDATA[		
					var so = new SWFObject("' . SITE_URL . 'js/amline/amline.swf", "amline1", "100%", "600", "8", "#FFFFFF");
                                        so.addParam("wmode", "transparent");
					so.addVariable("path", "' . SITE_URL . 'js/amline/");
          so.addVariable("chart_data", encodeURIComponent("' . $xml . '"));
          so.addVariable("chart_settings", encodeURIComponent(""));
					so.write("flashcontent");
					// ]]>
				</script></div>
			<!-- end of amline script -->
			';
        // -- Tableau de bord
        // -- Contenue de droite

        $out .= "                   </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                 </div>";

        // -- Contenue

            return $out;
    }

    function getXML() {

        $nbCol = count($this->dataGraph[0]) - 2;
        if ($nbCol > 1) {
            $alpha = 0;
        } else {
            $alpha = 30;
        }
        $series = "";
        for ($i = 0; $i < count($this->dataGraph); $i++) {
            $series.="<value xid='" . $i . "'>" . $this->dataGraph[$i][1] . "</value>";
            for ($k = 1; $k <= $nbCol; $k++) {
                if (!isset($graphs[$k]))
                    $graphs[$k] = "";
                $graphs[$k].="<value xid='" . $i . "'>" . $this->dataGraph[$i][$k + 1] . "</value>";
            }
        }
        $out = "<chart>";
        $out.="<series>";
        $out.=$series;
        $out.="</series>";
        $out.="<graphs>";

        for ($k = 1; $k <= $nbCol; $k++) {
            $out.="<graph gid='" . $k . "' fill_alpha='" . $alpha . "' title='" . $this->itemGraph[$k]['title'] . "'>";
            $out.=$graphs[$k];
            $out.="</graph>";
        }
        $out.="</graphs>";
        $out.="</chart>";

        return $out;
    }

    function getData() {

        $arrOut = array();
        if (!empty($this->request)) {
            $this->sql->query($this->request, SQL_ALL, SQL_ASSOC);
            $arrData = $this->sql->record;
        }
        else
            $arrData=array();

        $nbCol = count($this->labels) - 1;
        for ($i = 0; $i < count($arrData); $i++) {
            for ($j = 1; $j <= $nbCol; $j++) {
                $value[$arrData[$i]['libelle']][$j] = $arrData[$i]['result' . $j];
            }
        }

        $i = 0;

        if (empty($this->formvars['date_debut']))
            $this->formvars['date_debut'] = $arrData[0]['indice'];
        if (empty($this->formvars['date_fin']))
            $this->formvars['date_fin'] = $arrData[count($arrData) - 1]['indice'];

        //echo $arrData[count($arrData)-2]['commande_date_ajout'];
        switch ($this->formvars['group']) {
            case "day":
                $first = $this->formvars['date_debut'];
                $last = $this->formvars['date_fin'];
                while ($first <= $last) {
                    list($y, $m, $d) = explode("-", $first);
                    $first = date('Y-m-d', mktime(0, 0, 0, $m, $d + 1, $y));
                    $libelle = date('d-m-Y', mktime(0, 0, 0, $m, $d, $y));

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }
                    $i++;
                }
                break;
            case "week":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = date("YW", mktime(0, 0, 0, $m, $d, $y));
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = date("YW", mktime(0, 0, 0, $m, $d, $y));
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $w = substr($first, 4, 2);
                    if ($w < 10)
                        $w = substr($w, 1, 1);
                    $libelle = "Semaine " . $w . " - " . $y;
                    $w++;
                    if ($w > 52) {
                        $w = 1;
                        $y++;
                    }
                    if ($w < 10)
                        $w = "0" . $w;
                    $first = $y . $w;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "month":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = date("Ym", mktime(0, 0, 0, $m, $d, $y));
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = date("Ym", mktime(0, 0, 0, $m, $d, $y));
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $m = substr($first, 4, 2);
                    if ($m < 10)
                        $w = substr($m, 1, 1);
                    $libelle = $m . "-" . $y;
                    $m++;
                    if ($m > 12) {
                        $m = 1;
                        $y++;
                    }
                    if ($m < 10)
                        $m = "0" . $m;
                    $first = $y . $m;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "quarter":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                if ($m >= 1 || $m <= 3)
                    $q = "1";
                if ($m >= 4 || $m <= 6)
                    $q = "2";
                if ($m >= 7 || $m <= 9)
                    $q = "3";
                if ($m >= 10 || $m <= 12)
                    $q = "4";
                $first = $y . $q;
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                if ($m >= 1 || $m <= 3)
                    $q = "1";
                if ($m >= 4 || $m <= 6)
                    $q = "2";
                if ($m >= 7 || $m <= 9)
                    $q = "3";
                if ($m >= 10 || $m <= 12)
                    $q = "4";
                $last = $y . $q;
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $q = substr($first, 4, 1);

                    $libelle = "Trimestre " . $q . " - " . $y;
                    $q++;
                    if ($q > 4) {
                        $q = 1;
                        $y++;
                    }
                    $first = $y . $q;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "year":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = $y;
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = $y;
                while ($first <= $last) {
                    $y = $first;
                    $libelle = $y;
                    $y++;
                    $first = $y;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }

                break;

            case "produit":
            case "produit_attribut":
                foreach ($arrData as $val) {
                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $val['libelle'];
                    for ($k = 1; $k <= $nbCol; $k++) {
                        $arrOut[$i][$k + 1] = $val['result' . $k];
                    }
                    $i++;
                }

                break;
        }

        return $arrOut;
    }

//--
}