<?php

class bTag extends BackModule {


    function bTag($formvars = array()) {
        parent::BackModule($formvars);
    }

    function update($formvars = array(), $table = null, $langue = true) {
        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true) {
        return parent::create_multi($formvars, $table, $langue);
    }

    function delete($formvars = array(), $table = null, $langue = true) {
        return parent::delete_multi($formvars, $table, $langue);
    }

    function Form($formvars = array()) {

        if (empty($formvars['id']))
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'un nouveau Tag</a></span>";
        else {
            $sql = "SELECT tag_nom_nom as data FROM tag_nom WHERE tag_id = '" . $formvars['id'] . "' AND langue_id = '" . LANGUE . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition du Tag : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql.=" FROM tag t, tag_nom tn";
            $sql.=" WHERE t.tag_id='" . $formvars['id'] . "'";
            $sql.=" AND t.tag_id = tn.tag_id";
            $sql.=" AND tn.langue_id='" . LANGUE . "'";

            $this->request = getTableMutli('tag', $formvars['id']);
        }
        //-- SQL
        // Champs du formulaire
        //GROUP
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "tag_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        //-- Champs du formulaire

        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array()) {

        // SQL
        $sql = "SELECT t.tag_id, t.tag_id, tn.tag_nom_nom";
        $sql.=" FROM (tag t)";
        $sql.=" LEFT JOIN tag_nom tn ON (tn.tag_id = t.tag_id AND tn.langue_id = '" . LANGUE . "')";
        $sql.=" WHERE 1";

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("TRADUCTIONS", 'translate');
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }
    
    
    function autocomplete($formvars = array()) {
    	
        $out = "";
        if (isset($formvars['tag_nom_nom']) && !empty($formvars['tag_nom_nom']) && strlen($formvars['tag_nom_nom']) > 0) {
            $tag = new Tag();
            $arrArt = $tag->getAutoComplete(array('search' => $formvars['tag_nom_nom']));
            $i = 1;
            foreach ($arrArt as $arti) {
                $out.="<input style='display:none;' id='input_produit_" . $arti['tag_id'] . "' value='" . $arti['tag_nom_nom'] . "'/>";
                $value = $arti['tag_id'] . " / " . $arti['tag_nom_nom'];
                $value = mb_eregi_replace("(" . $formvars['tag_nom_nom'] . ")", "<strong>\\1</strong>", $value);
                $out .="<div class='results " . (($i) ? 'highlight' : '') . "' id='produit_" . $arti['tag_id'] . "'>" . $value . "</div>";
                $i = abs($i - 1);
            }

            if (!$out)
                $out = "<div>Entrez le nom d'un tag</div>";
        }
        else
            $out="<div>Entrez le nom d'un tag</div>";

        return $out;
    }

//--
}