<?php

use Phinx\Seed\AbstractSeed;

/**
 * Class GroupClient
 * civilite
 * civilite_nom
 */
class GroupClient extends AbstractSeed
{
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here:
     * http://docs.phinx.org/en/latest/seeding.html
     */
    public function run()
    {

        $dataCivilite = [
            [
                'civilite_id' => 1,
            ],
            [
                'civilite_id' => 2,
            ],
            [
                'civilite_id' => 3,
            ],
        ];
        $this->table('civilite')
            ->insert($dataCivilite)
            ->save();


        $dataCiviliteNom = [
            [
                'civilite_nom_id' => 1,
                'civilite_id' => 1,
                'civilite_nom_nom' => 'M',
            ],
            [
                'civilite_nom_id' => 2,
                'civilite_id' => 2,
                'civilite_nom_nom' => 'Mme',
            ],
            [
                'civilite_nom_id' => 3,
                'civilite_id' => 3,
                'civilite_nom_nom' => 'Mlle',
            ],
        ];
        $this->table('civilite_nom')
            ->insert($dataCiviliteNom)
            ->save();

    }
}
