<?php

use Phinx\Seed\AbstractSeed;

/**
 * Created by PhpStorm.
 * User: Yannick
 * Date: 12/03/2016
 * Time: 14:33
 */
class GroupGeneral extends AbstractSeed
{

    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here:
     * http://docs.phinx.org/en/latest/seeding.html
     */
    public function run()
    {

        $dataLang = [
            [
                'langue_nom' => 'Français',
                'langue_ini' => 'FR',
                'langue_img' => '/back/styles/images/lang/FR.png',
                'langue_img_site' => '/media/lang/FR.png',
                'langue_rang' => 0,
                'actif_id' => 1
            ],
        ];
        $this->table('langue')
            ->insert($dataLang)
            ->save();

        $this->query("
            INSERT IGNORE INTO langue_boutique (langue_id, boutique_id, langue_boutique_statut_id)
            SELECT l.langue_id, boutique_id, 1
            FROM langue l
            CROSS JOIN boutique b
        ");

    }

}